package com.tzld.piaoquan.longarticle.service.local.impl;

import com.tzld.piaoquan.longarticle.dao.mapper.longarticle.AccountSpecialSettingsMapper;
import com.tzld.piaoquan.longarticle.model.po.longarticle.AccountSpecialSettings;
import com.tzld.piaoquan.longarticle.model.po.longarticle.AccountSpecialSettingsExample;
import com.tzld.piaoquan.longarticle.service.local.AccountService;
import com.tzld.piaoquan.longarticle.utils.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

@Service
public class AccountServiceImpl implements AccountService {

    @Autowired
    private AccountSpecialSettingsMapper accountSpecialSettingsMapper;

    @Override
    public List<AccountSpecialSettings> getAccountSpecialSettings() {
        String dateString = DateUtil.getThatDayDateString();
        AccountSpecialSettingsExample example = new AccountSpecialSettingsExample();
        example.createCriteria().andEffectiveDateEqualTo(dateString).andIsDeleteEqualTo(0);
        return accountSpecialSettingsMapper.selectByExample(example);
    }

    public List<AccountSpecialSettings> getSendAccountSpecialSettings() {
        String dateString = DateUtil.getTomorrowDateString();
        AccountSpecialSettingsExample example = new AccountSpecialSettingsExample();
        example.createCriteria().andEffectiveDateEqualTo(dateString).andIsDeleteEqualTo(0);
        return accountSpecialSettingsMapper.selectByExample(example);
    }

    public void saveOrUpdateAccountSpecialSettings(AccountSpecialSettings accountSpecialSettings) {
        AccountSpecialSettingsExample example = new AccountSpecialSettingsExample();
        example.createCriteria().andAccountIdEqualTo(accountSpecialSettings.getAccountId())
                .andEffectiveDateEqualTo(accountSpecialSettings.getEffectiveDate());
        List<AccountSpecialSettings> accountSpecialSettingsList = accountSpecialSettingsMapper.selectByExample(example);
        if (CollectionUtils.isEmpty(accountSpecialSettingsList)) {
            accountSpecialSettingsMapper.insertSelective(accountSpecialSettings);
        } else {
            accountSpecialSettings.setId(accountSpecialSettingsList.get(0).getId());
            accountSpecialSettings.setIsDelete(0);
            accountSpecialSettingsMapper.updateByPrimaryKeySelective(accountSpecialSettings);
        }
    }

    @Override
    public boolean isSendSpecialSettings(String accountId) {
        String dateString = DateUtil.getTomorrowDateString();
        AccountSpecialSettingsExample example = new AccountSpecialSettingsExample();
        example.createCriteria().andEffectiveDateEqualTo(dateString)
                .andAccountIdEqualTo(accountId).andIsDeleteEqualTo(0);
        return accountSpecialSettingsMapper.countByExample(example) > 0;
    }


}
