package com.tzld.piaoquan.longarticle.utils.other;

import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
public class KimiAPI {

    /**
     * 聊天端点
     */
    static String chatEndpoint = "https://api.moonshot.cn/v1/chat/completions";
    /**
     * api密匙
     */
    static String apiKey = "Bearer sk-5DqYCa88kche6nwIWjLE1p4oMm8nXrR9kQMKbBolNAWERu7q";

    /**
     * 发送消息
     *
     * @param txt 内容
     * @return {@link String}
     */
    public static String chat(String txt) {
        Map<String, Object> paramMap = new HashMap<>();
        paramMap.put("model", "moonshot-v1-8k");
        List<Map<String, String>> dataList = new ArrayList<>();
        dataList.add(new HashMap<String, String>() {{
            put("role", "user");
            put("content", txt);
        }});
        paramMap.put("messages", dataList);
        JSONObject message = null;
        try {
            String body = HttpRequest.post(chatEndpoint)
                    .header("Authorization", apiKey)
                    .header("Content-Type", "application/json")
                    .body(JSONObject.toJSONString(paramMap))
                    .timeout(60000)
                    .execute()
                    .body();
            JSONObject jsonObject = JSONObject.parseObject(body);
            JSONArray choices = jsonObject.getJSONArray("choices");
            JSONObject result = choices.getJSONObject(0);
            message = result.getJSONObject("message");
            return message.getString("content");
        } catch (Exception e) {
            log.error("KimiAPI chat error", e);
        }
        return "";
    }

    public static String jsonChat(String txt) {
        Map<String, Object> paramMap = new HashMap<>();
        paramMap.put("model", "moonshot-v1-8k");
        List<Map<String, String>> dataList = new ArrayList<>();
        dataList.add(new HashMap<String, String>() {{
            put("role", "user");
            put("content", txt);
        }});
        paramMap.put("messages", dataList);
        Map<String, String> responseFormat = new HashMap<>();
        responseFormat.put("type", "json_object");
        paramMap.put("response_format", responseFormat);
        JSONObject message = null;
        try {
            String body = HttpRequest.post(chatEndpoint)
                    .header("Authorization", apiKey)
                    .header("Content-Type", "application/json")
                    .body(JSONObject.toJSONString(paramMap))
                    .timeout(60000)
                    .execute()
                    .body();
            JSONObject jsonObject = JSONObject.parseObject(body);
            JSONArray choices = jsonObject.getJSONArray("choices");
            JSONObject result = choices.getJSONObject(0);
            message = result.getJSONObject("message");
            return message.getString("content");
        } catch (Exception e) {
            log.error("KimiAPI chat error", e);
        }
        return "";
    }
}
